/* PM 2017
 * Radu Ioana-Roxana
 * 
 * Implementarea functiilor necesare comunicarii prin SPI.
 * Sursa: laboratorul 4 PM 2017.
 *
 */


#include <avr/io.h>

#include "spi.h"

/* Face configurarile necesare initializarii SPI */
void SPI_init(void)
{
	/* seteaza directia SPI : MOSI si SCK ca output, MISO ca input */
	SPI_DDR |= (1 << SPI_MOSI) | (1 << SPI_SCK);
	SPI_DDR &= ~(1 << SPI_MISO);
	
	/* initialize SPI */
	SPCR =  (1 << SPE) |			// enable
		(1 << MSTR) |			// master mode
		(0 << DORD) |			// MSB first
		(0 << CPOL) | (0 << CPHA) |	// mode 0
		(0 << SPR0);			// f_osc / 2
	SPSR |= (1 << SPI2X);			// f_osc / 2
}

/* Schimba un octet prin SPI*/
uint8_t SPI_exchange(uint8_t data)
{
	SPDR = data;
	while(!(SPSR & (1 << SPIF))) ;
	return SPDR;
}

